// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:action/MoveBase.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__TRAITS_HPP_

#include "py_trees_ros_interfaces/action/move_base__struct.hpp"
#include <rosidl_generator_cpp/traits.hpp>
#include <stdint.h>
#include <type_traits>

// Include directives for member types
// Member 'target_pose'
#include "geometry_msgs/msg/pose_stamped__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_Goal>()
{
  return "py_trees_ros_interfaces::action::MoveBase_Goal";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Goal>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Goal>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PoseStamped>::value> {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_Result>()
{
  return "py_trees_ros_interfaces::action::MoveBase_Result";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Result>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Result>
  : std::integral_constant<bool, false> {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'base_position'
// already included above
// #include "geometry_msgs/msg/pose_stamped__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_Feedback>()
{
  return "py_trees_ros_interfaces::action::MoveBase_Feedback";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Feedback>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::PoseStamped>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Feedback>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::PoseStamped>::value> {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/uuid__traits.hpp"
// Member 'goal'
#include "py_trees_ros_interfaces/action/move_base__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_SendGoal_Request>()
{
  return "py_trees_ros_interfaces::action::MoveBase_SendGoal_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/time__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_SendGoal_Response>()
{
  return "py_trees_ros_interfaces::action::MoveBase_SendGoal_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_SendGoal>()
{
  return "py_trees_ros_interfaces::action::MoveBase_SendGoal";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::action::MoveBase_SendGoal_Response>::value
  >
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_GetResult_Request>()
{
  return "py_trees_ros_interfaces::action::MoveBase_GetResult_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "py_trees_ros_interfaces/action/move_base__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_GetResult_Response>()
{
  return "py_trees_ros_interfaces::action::MoveBase_GetResult_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Result>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Result>::value> {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_GetResult>()
{
  return "py_trees_ros_interfaces::action::MoveBase_GetResult";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::action::MoveBase_GetResult_Response>::value
  >
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "py_trees_ros_interfaces/action/move_base__traits.hpp"

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::action::MoveBase_FeedbackMessage>()
{
  return "py_trees_ros_interfaces::action::MoveBase_FeedbackMessage";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::action::MoveBase_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<py_trees_ros_interfaces::action::MoveBase_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::action::MoveBase_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::action::MoveBase_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__ACTION__MOVE_BASE__TRAITS_HPP_
