#ifndef _H_56927319624649C373B450C387F7E2AA_CloseBlackboardWatcher_DCPS_H_
#define _H_56927319624649C373B450C387F7E2AA_CloseBlackboardWatcher_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CloseBlackboardWatcher_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class CloseBlackboardWatcher_Request_TypeSupportInterface;

            typedef CloseBlackboardWatcher_Request_TypeSupportInterface * CloseBlackboardWatcher_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Request_TypeSupportInterface> CloseBlackboardWatcher_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Request_TypeSupportInterface> CloseBlackboardWatcher_Request_TypeSupportInterface_out;


            class CloseBlackboardWatcher_Request_DataWriter;

            typedef CloseBlackboardWatcher_Request_DataWriter * CloseBlackboardWatcher_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Request_DataWriter> CloseBlackboardWatcher_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Request_DataWriter> CloseBlackboardWatcher_Request_DataWriter_out;


            class CloseBlackboardWatcher_Request_DataReader;

            typedef CloseBlackboardWatcher_Request_DataReader * CloseBlackboardWatcher_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Request_DataReader> CloseBlackboardWatcher_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Request_DataReader> CloseBlackboardWatcher_Request_DataReader_out;


            class CloseBlackboardWatcher_Request_DataReaderView;

            typedef CloseBlackboardWatcher_Request_DataReaderView * CloseBlackboardWatcher_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Request_DataReaderView> CloseBlackboardWatcher_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Request_DataReaderView> CloseBlackboardWatcher_Request_DataReaderView_out;

            struct CloseBlackboardWatcher_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CloseBlackboardWatcher_Request_, struct CloseBlackboardWatcher_Request_Seq_uniq_> CloseBlackboardWatcher_Request_Seq;
            typedef DDS_DCPSSequence_var < CloseBlackboardWatcher_Request_Seq> CloseBlackboardWatcher_Request_Seq_var;
            typedef DDS_DCPSSequence_out < CloseBlackboardWatcher_Request_Seq> CloseBlackboardWatcher_Request_Seq_out;

            class  CloseBlackboardWatcher_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Request_TypeSupportInterface_var _var_type;

                static CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _duplicate (CloseBlackboardWatcher_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseBlackboardWatcher_Request_TypeSupportInterface () {};
                ~CloseBlackboardWatcher_Request_TypeSupportInterface () {};
            private:
                CloseBlackboardWatcher_Request_TypeSupportInterface (const CloseBlackboardWatcher_Request_TypeSupportInterface &);
                CloseBlackboardWatcher_Request_TypeSupportInterface & operator = (const CloseBlackboardWatcher_Request_TypeSupportInterface &);
            };

            class  CloseBlackboardWatcher_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseBlackboardWatcher_Request_DataWriter_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Request_DataWriter_var _var_type;

                static CloseBlackboardWatcher_Request_DataWriter_ptr _duplicate (CloseBlackboardWatcher_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseBlackboardWatcher_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseBlackboardWatcher_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Request_& instance_data) = 0;

            protected:
                CloseBlackboardWatcher_Request_DataWriter () {};
                ~CloseBlackboardWatcher_Request_DataWriter () {};
            private:
                CloseBlackboardWatcher_Request_DataWriter (const CloseBlackboardWatcher_Request_DataWriter &);
                CloseBlackboardWatcher_Request_DataWriter & operator = (const CloseBlackboardWatcher_Request_DataWriter &);
            };

            class  CloseBlackboardWatcher_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseBlackboardWatcher_Request_DataReader_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Request_DataReader_var _var_type;

                static CloseBlackboardWatcher_Request_DataReader_ptr _duplicate (CloseBlackboardWatcher_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Request_& instance) = 0;

            protected:
                CloseBlackboardWatcher_Request_DataReader () {};
                ~CloseBlackboardWatcher_Request_DataReader () {};
            private:
                CloseBlackboardWatcher_Request_DataReader (const CloseBlackboardWatcher_Request_DataReader &);
                CloseBlackboardWatcher_Request_DataReader & operator = (const CloseBlackboardWatcher_Request_DataReader &);
            };

            class  CloseBlackboardWatcher_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseBlackboardWatcher_Request_DataReaderView_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Request_DataReaderView_var _var_type;

                static CloseBlackboardWatcher_Request_DataReaderView_ptr _duplicate (CloseBlackboardWatcher_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Request_& instance) = 0;

            protected:
                CloseBlackboardWatcher_Request_DataReaderView () {};
                ~CloseBlackboardWatcher_Request_DataReaderView () {};
            private:
                CloseBlackboardWatcher_Request_DataReaderView (const CloseBlackboardWatcher_Request_DataReaderView &);
                CloseBlackboardWatcher_Request_DataReaderView & operator = (const CloseBlackboardWatcher_Request_DataReaderView &);
            };
            class CloseBlackboardWatcher_Response_TypeSupportInterface;

            typedef CloseBlackboardWatcher_Response_TypeSupportInterface * CloseBlackboardWatcher_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Response_TypeSupportInterface> CloseBlackboardWatcher_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Response_TypeSupportInterface> CloseBlackboardWatcher_Response_TypeSupportInterface_out;


            class CloseBlackboardWatcher_Response_DataWriter;

            typedef CloseBlackboardWatcher_Response_DataWriter * CloseBlackboardWatcher_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Response_DataWriter> CloseBlackboardWatcher_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Response_DataWriter> CloseBlackboardWatcher_Response_DataWriter_out;


            class CloseBlackboardWatcher_Response_DataReader;

            typedef CloseBlackboardWatcher_Response_DataReader * CloseBlackboardWatcher_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Response_DataReader> CloseBlackboardWatcher_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Response_DataReader> CloseBlackboardWatcher_Response_DataReader_out;


            class CloseBlackboardWatcher_Response_DataReaderView;

            typedef CloseBlackboardWatcher_Response_DataReaderView * CloseBlackboardWatcher_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CloseBlackboardWatcher_Response_DataReaderView> CloseBlackboardWatcher_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CloseBlackboardWatcher_Response_DataReaderView> CloseBlackboardWatcher_Response_DataReaderView_out;

            struct CloseBlackboardWatcher_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CloseBlackboardWatcher_Response_, struct CloseBlackboardWatcher_Response_Seq_uniq_> CloseBlackboardWatcher_Response_Seq;
            typedef DDS_DCPSSequence_var < CloseBlackboardWatcher_Response_Seq> CloseBlackboardWatcher_Response_Seq_var;
            typedef DDS_DCPSSequence_out < CloseBlackboardWatcher_Response_Seq> CloseBlackboardWatcher_Response_Seq_out;

            class  CloseBlackboardWatcher_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Response_TypeSupportInterface_var _var_type;

                static CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _duplicate (CloseBlackboardWatcher_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CloseBlackboardWatcher_Response_TypeSupportInterface () {};
                ~CloseBlackboardWatcher_Response_TypeSupportInterface () {};
            private:
                CloseBlackboardWatcher_Response_TypeSupportInterface (const CloseBlackboardWatcher_Response_TypeSupportInterface &);
                CloseBlackboardWatcher_Response_TypeSupportInterface & operator = (const CloseBlackboardWatcher_Response_TypeSupportInterface &);
            };

            class  CloseBlackboardWatcher_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CloseBlackboardWatcher_Response_DataWriter_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Response_DataWriter_var _var_type;

                static CloseBlackboardWatcher_Response_DataWriter_ptr _duplicate (CloseBlackboardWatcher_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CloseBlackboardWatcher_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CloseBlackboardWatcher_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Response_& instance_data) = 0;

            protected:
                CloseBlackboardWatcher_Response_DataWriter () {};
                ~CloseBlackboardWatcher_Response_DataWriter () {};
            private:
                CloseBlackboardWatcher_Response_DataWriter (const CloseBlackboardWatcher_Response_DataWriter &);
                CloseBlackboardWatcher_Response_DataWriter & operator = (const CloseBlackboardWatcher_Response_DataWriter &);
            };

            class  CloseBlackboardWatcher_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CloseBlackboardWatcher_Response_DataReader_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Response_DataReader_var _var_type;

                static CloseBlackboardWatcher_Response_DataReader_ptr _duplicate (CloseBlackboardWatcher_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Response_& instance) = 0;

            protected:
                CloseBlackboardWatcher_Response_DataReader () {};
                ~CloseBlackboardWatcher_Response_DataReader () {};
            private:
                CloseBlackboardWatcher_Response_DataReader (const CloseBlackboardWatcher_Response_DataReader &);
                CloseBlackboardWatcher_Response_DataReader & operator = (const CloseBlackboardWatcher_Response_DataReader &);
            };

            class  CloseBlackboardWatcher_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CloseBlackboardWatcher_Response_DataReaderView_ptr _ptr_type;
                typedef CloseBlackboardWatcher_Response_DataReaderView_var _var_type;

                static CloseBlackboardWatcher_Response_DataReaderView_ptr _duplicate (CloseBlackboardWatcher_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CloseBlackboardWatcher_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CloseBlackboardWatcher_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CloseBlackboardWatcher_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CloseBlackboardWatcher_Response_& instance) = 0;

            protected:
                CloseBlackboardWatcher_Response_DataReaderView () {};
                ~CloseBlackboardWatcher_Response_DataReaderView () {};
            private:
                CloseBlackboardWatcher_Response_DataReaderView (const CloseBlackboardWatcher_Response_DataReaderView &);
                CloseBlackboardWatcher_Response_DataReaderView & operator = (const CloseBlackboardWatcher_Response_DataReaderView &);
            };
            class Sample_CloseBlackboardWatcher_Request_TypeSupportInterface;

            typedef Sample_CloseBlackboardWatcher_Request_TypeSupportInterface * Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Request_TypeSupportInterface> Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Request_TypeSupportInterface> Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_out;


            class Sample_CloseBlackboardWatcher_Request_DataWriter;

            typedef Sample_CloseBlackboardWatcher_Request_DataWriter * Sample_CloseBlackboardWatcher_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Request_DataWriter> Sample_CloseBlackboardWatcher_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Request_DataWriter> Sample_CloseBlackboardWatcher_Request_DataWriter_out;


            class Sample_CloseBlackboardWatcher_Request_DataReader;

            typedef Sample_CloseBlackboardWatcher_Request_DataReader * Sample_CloseBlackboardWatcher_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Request_DataReader> Sample_CloseBlackboardWatcher_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Request_DataReader> Sample_CloseBlackboardWatcher_Request_DataReader_out;


            class Sample_CloseBlackboardWatcher_Request_DataReaderView;

            typedef Sample_CloseBlackboardWatcher_Request_DataReaderView * Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Request_DataReaderView> Sample_CloseBlackboardWatcher_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Request_DataReaderView> Sample_CloseBlackboardWatcher_Request_DataReaderView_out;

            struct Sample_CloseBlackboardWatcher_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_CloseBlackboardWatcher_Request_, struct Sample_CloseBlackboardWatcher_Request_Seq_uniq_> Sample_CloseBlackboardWatcher_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseBlackboardWatcher_Request_Seq> Sample_CloseBlackboardWatcher_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseBlackboardWatcher_Request_Seq> Sample_CloseBlackboardWatcher_Request_Seq_out;

            class  Sample_CloseBlackboardWatcher_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_var _var_type;

                static Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _duplicate (Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseBlackboardWatcher_Request_TypeSupportInterface () {};
                ~Sample_CloseBlackboardWatcher_Request_TypeSupportInterface () {};
            private:
                Sample_CloseBlackboardWatcher_Request_TypeSupportInterface (const Sample_CloseBlackboardWatcher_Request_TypeSupportInterface &);
                Sample_CloseBlackboardWatcher_Request_TypeSupportInterface & operator = (const Sample_CloseBlackboardWatcher_Request_TypeSupportInterface &);
            };

            class  Sample_CloseBlackboardWatcher_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Request_DataWriter_var _var_type;

                static Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _duplicate (Sample_CloseBlackboardWatcher_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseBlackboardWatcher_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseBlackboardWatcher_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Request_& instance_data) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Request_DataWriter () {};
                ~Sample_CloseBlackboardWatcher_Request_DataWriter () {};
            private:
                Sample_CloseBlackboardWatcher_Request_DataWriter (const Sample_CloseBlackboardWatcher_Request_DataWriter &);
                Sample_CloseBlackboardWatcher_Request_DataWriter & operator = (const Sample_CloseBlackboardWatcher_Request_DataWriter &);
            };

            class  Sample_CloseBlackboardWatcher_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Request_DataReader_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Request_DataReader_var _var_type;

                static Sample_CloseBlackboardWatcher_Request_DataReader_ptr _duplicate (Sample_CloseBlackboardWatcher_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Request_& instance) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Request_DataReader () {};
                ~Sample_CloseBlackboardWatcher_Request_DataReader () {};
            private:
                Sample_CloseBlackboardWatcher_Request_DataReader (const Sample_CloseBlackboardWatcher_Request_DataReader &);
                Sample_CloseBlackboardWatcher_Request_DataReader & operator = (const Sample_CloseBlackboardWatcher_Request_DataReader &);
            };

            class  Sample_CloseBlackboardWatcher_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Request_DataReaderView_var _var_type;

                static Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _duplicate (Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Request_& instance) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Request_DataReaderView () {};
                ~Sample_CloseBlackboardWatcher_Request_DataReaderView () {};
            private:
                Sample_CloseBlackboardWatcher_Request_DataReaderView (const Sample_CloseBlackboardWatcher_Request_DataReaderView &);
                Sample_CloseBlackboardWatcher_Request_DataReaderView & operator = (const Sample_CloseBlackboardWatcher_Request_DataReaderView &);
            };
            class Sample_CloseBlackboardWatcher_Response_TypeSupportInterface;

            typedef Sample_CloseBlackboardWatcher_Response_TypeSupportInterface * Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Response_TypeSupportInterface> Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Response_TypeSupportInterface> Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_out;


            class Sample_CloseBlackboardWatcher_Response_DataWriter;

            typedef Sample_CloseBlackboardWatcher_Response_DataWriter * Sample_CloseBlackboardWatcher_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Response_DataWriter> Sample_CloseBlackboardWatcher_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Response_DataWriter> Sample_CloseBlackboardWatcher_Response_DataWriter_out;


            class Sample_CloseBlackboardWatcher_Response_DataReader;

            typedef Sample_CloseBlackboardWatcher_Response_DataReader * Sample_CloseBlackboardWatcher_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Response_DataReader> Sample_CloseBlackboardWatcher_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Response_DataReader> Sample_CloseBlackboardWatcher_Response_DataReader_out;


            class Sample_CloseBlackboardWatcher_Response_DataReaderView;

            typedef Sample_CloseBlackboardWatcher_Response_DataReaderView * Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CloseBlackboardWatcher_Response_DataReaderView> Sample_CloseBlackboardWatcher_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CloseBlackboardWatcher_Response_DataReaderView> Sample_CloseBlackboardWatcher_Response_DataReaderView_out;

            struct Sample_CloseBlackboardWatcher_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_CloseBlackboardWatcher_Response_, struct Sample_CloseBlackboardWatcher_Response_Seq_uniq_> Sample_CloseBlackboardWatcher_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_CloseBlackboardWatcher_Response_Seq> Sample_CloseBlackboardWatcher_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CloseBlackboardWatcher_Response_Seq> Sample_CloseBlackboardWatcher_Response_Seq_out;

            class  Sample_CloseBlackboardWatcher_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_var _var_type;

                static Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _duplicate (Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CloseBlackboardWatcher_Response_TypeSupportInterface () {};
                ~Sample_CloseBlackboardWatcher_Response_TypeSupportInterface () {};
            private:
                Sample_CloseBlackboardWatcher_Response_TypeSupportInterface (const Sample_CloseBlackboardWatcher_Response_TypeSupportInterface &);
                Sample_CloseBlackboardWatcher_Response_TypeSupportInterface & operator = (const Sample_CloseBlackboardWatcher_Response_TypeSupportInterface &);
            };

            class  Sample_CloseBlackboardWatcher_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Response_DataWriter_var _var_type;

                static Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _duplicate (Sample_CloseBlackboardWatcher_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CloseBlackboardWatcher_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CloseBlackboardWatcher_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CloseBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Response_& instance_data) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Response_DataWriter () {};
                ~Sample_CloseBlackboardWatcher_Response_DataWriter () {};
            private:
                Sample_CloseBlackboardWatcher_Response_DataWriter (const Sample_CloseBlackboardWatcher_Response_DataWriter &);
                Sample_CloseBlackboardWatcher_Response_DataWriter & operator = (const Sample_CloseBlackboardWatcher_Response_DataWriter &);
            };

            class  Sample_CloseBlackboardWatcher_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Response_DataReader_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Response_DataReader_var _var_type;

                static Sample_CloseBlackboardWatcher_Response_DataReader_ptr _duplicate (Sample_CloseBlackboardWatcher_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Response_& instance) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Response_DataReader () {};
                ~Sample_CloseBlackboardWatcher_Response_DataReader () {};
            private:
                Sample_CloseBlackboardWatcher_Response_DataReader (const Sample_CloseBlackboardWatcher_Response_DataReader &);
                Sample_CloseBlackboardWatcher_Response_DataReader & operator = (const Sample_CloseBlackboardWatcher_Response_DataReader &);
            };

            class  Sample_CloseBlackboardWatcher_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_CloseBlackboardWatcher_Response_DataReaderView_var _var_type;

                static Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _duplicate (Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CloseBlackboardWatcher_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CloseBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CloseBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CloseBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CloseBlackboardWatcher_Response_& instance) = 0;

            protected:
                Sample_CloseBlackboardWatcher_Response_DataReaderView () {};
                ~Sample_CloseBlackboardWatcher_Response_DataReaderView () {};
            private:
                Sample_CloseBlackboardWatcher_Response_DataReaderView (const Sample_CloseBlackboardWatcher_Response_DataReaderView &);
                Sample_CloseBlackboardWatcher_Response_DataReaderView & operator = (const Sample_CloseBlackboardWatcher_Response_DataReaderView &);
            };
        }

    }

}

#endif
