#ifndef _H_25C31FC2351662334F9A1D62939BD44B_GetBlackboardVariables_DCPS_H_
#define _H_25C31FC2351662334F9A1D62939BD44B_GetBlackboardVariables_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetBlackboardVariables_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class GetBlackboardVariables_Request_TypeSupportInterface;

            typedef GetBlackboardVariables_Request_TypeSupportInterface * GetBlackboardVariables_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Request_TypeSupportInterface> GetBlackboardVariables_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Request_TypeSupportInterface> GetBlackboardVariables_Request_TypeSupportInterface_out;


            class GetBlackboardVariables_Request_DataWriter;

            typedef GetBlackboardVariables_Request_DataWriter * GetBlackboardVariables_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Request_DataWriter> GetBlackboardVariables_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Request_DataWriter> GetBlackboardVariables_Request_DataWriter_out;


            class GetBlackboardVariables_Request_DataReader;

            typedef GetBlackboardVariables_Request_DataReader * GetBlackboardVariables_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Request_DataReader> GetBlackboardVariables_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Request_DataReader> GetBlackboardVariables_Request_DataReader_out;


            class GetBlackboardVariables_Request_DataReaderView;

            typedef GetBlackboardVariables_Request_DataReaderView * GetBlackboardVariables_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Request_DataReaderView> GetBlackboardVariables_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Request_DataReaderView> GetBlackboardVariables_Request_DataReaderView_out;

            struct GetBlackboardVariables_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetBlackboardVariables_Request_, struct GetBlackboardVariables_Request_Seq_uniq_> GetBlackboardVariables_Request_Seq;
            typedef DDS_DCPSSequence_var < GetBlackboardVariables_Request_Seq> GetBlackboardVariables_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetBlackboardVariables_Request_Seq> GetBlackboardVariables_Request_Seq_out;

            class  GetBlackboardVariables_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetBlackboardVariables_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetBlackboardVariables_Request_TypeSupportInterface_var _var_type;

                static GetBlackboardVariables_Request_TypeSupportInterface_ptr _duplicate (GetBlackboardVariables_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetBlackboardVariables_Request_TypeSupportInterface () {};
                ~GetBlackboardVariables_Request_TypeSupportInterface () {};
            private:
                GetBlackboardVariables_Request_TypeSupportInterface (const GetBlackboardVariables_Request_TypeSupportInterface &);
                GetBlackboardVariables_Request_TypeSupportInterface & operator = (const GetBlackboardVariables_Request_TypeSupportInterface &);
            };

            class  GetBlackboardVariables_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetBlackboardVariables_Request_DataWriter_ptr _ptr_type;
                typedef GetBlackboardVariables_Request_DataWriter_var _var_type;

                static GetBlackboardVariables_Request_DataWriter_ptr _duplicate (GetBlackboardVariables_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetBlackboardVariables_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetBlackboardVariables_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Request_& instance_data) = 0;

            protected:
                GetBlackboardVariables_Request_DataWriter () {};
                ~GetBlackboardVariables_Request_DataWriter () {};
            private:
                GetBlackboardVariables_Request_DataWriter (const GetBlackboardVariables_Request_DataWriter &);
                GetBlackboardVariables_Request_DataWriter & operator = (const GetBlackboardVariables_Request_DataWriter &);
            };

            class  GetBlackboardVariables_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetBlackboardVariables_Request_DataReader_ptr _ptr_type;
                typedef GetBlackboardVariables_Request_DataReader_var _var_type;

                static GetBlackboardVariables_Request_DataReader_ptr _duplicate (GetBlackboardVariables_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Request_& instance) = 0;

            protected:
                GetBlackboardVariables_Request_DataReader () {};
                ~GetBlackboardVariables_Request_DataReader () {};
            private:
                GetBlackboardVariables_Request_DataReader (const GetBlackboardVariables_Request_DataReader &);
                GetBlackboardVariables_Request_DataReader & operator = (const GetBlackboardVariables_Request_DataReader &);
            };

            class  GetBlackboardVariables_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetBlackboardVariables_Request_DataReaderView_ptr _ptr_type;
                typedef GetBlackboardVariables_Request_DataReaderView_var _var_type;

                static GetBlackboardVariables_Request_DataReaderView_ptr _duplicate (GetBlackboardVariables_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Request_& instance) = 0;

            protected:
                GetBlackboardVariables_Request_DataReaderView () {};
                ~GetBlackboardVariables_Request_DataReaderView () {};
            private:
                GetBlackboardVariables_Request_DataReaderView (const GetBlackboardVariables_Request_DataReaderView &);
                GetBlackboardVariables_Request_DataReaderView & operator = (const GetBlackboardVariables_Request_DataReaderView &);
            };
            class GetBlackboardVariables_Response_TypeSupportInterface;

            typedef GetBlackboardVariables_Response_TypeSupportInterface * GetBlackboardVariables_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Response_TypeSupportInterface> GetBlackboardVariables_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Response_TypeSupportInterface> GetBlackboardVariables_Response_TypeSupportInterface_out;


            class GetBlackboardVariables_Response_DataWriter;

            typedef GetBlackboardVariables_Response_DataWriter * GetBlackboardVariables_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Response_DataWriter> GetBlackboardVariables_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Response_DataWriter> GetBlackboardVariables_Response_DataWriter_out;


            class GetBlackboardVariables_Response_DataReader;

            typedef GetBlackboardVariables_Response_DataReader * GetBlackboardVariables_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Response_DataReader> GetBlackboardVariables_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Response_DataReader> GetBlackboardVariables_Response_DataReader_out;


            class GetBlackboardVariables_Response_DataReaderView;

            typedef GetBlackboardVariables_Response_DataReaderView * GetBlackboardVariables_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetBlackboardVariables_Response_DataReaderView> GetBlackboardVariables_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetBlackboardVariables_Response_DataReaderView> GetBlackboardVariables_Response_DataReaderView_out;

            struct GetBlackboardVariables_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetBlackboardVariables_Response_, struct GetBlackboardVariables_Response_Seq_uniq_> GetBlackboardVariables_Response_Seq;
            typedef DDS_DCPSSequence_var < GetBlackboardVariables_Response_Seq> GetBlackboardVariables_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetBlackboardVariables_Response_Seq> GetBlackboardVariables_Response_Seq_out;

            class  GetBlackboardVariables_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetBlackboardVariables_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetBlackboardVariables_Response_TypeSupportInterface_var _var_type;

                static GetBlackboardVariables_Response_TypeSupportInterface_ptr _duplicate (GetBlackboardVariables_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetBlackboardVariables_Response_TypeSupportInterface () {};
                ~GetBlackboardVariables_Response_TypeSupportInterface () {};
            private:
                GetBlackboardVariables_Response_TypeSupportInterface (const GetBlackboardVariables_Response_TypeSupportInterface &);
                GetBlackboardVariables_Response_TypeSupportInterface & operator = (const GetBlackboardVariables_Response_TypeSupportInterface &);
            };

            class  GetBlackboardVariables_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetBlackboardVariables_Response_DataWriter_ptr _ptr_type;
                typedef GetBlackboardVariables_Response_DataWriter_var _var_type;

                static GetBlackboardVariables_Response_DataWriter_ptr _duplicate (GetBlackboardVariables_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetBlackboardVariables_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetBlackboardVariables_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Response_& instance_data) = 0;

            protected:
                GetBlackboardVariables_Response_DataWriter () {};
                ~GetBlackboardVariables_Response_DataWriter () {};
            private:
                GetBlackboardVariables_Response_DataWriter (const GetBlackboardVariables_Response_DataWriter &);
                GetBlackboardVariables_Response_DataWriter & operator = (const GetBlackboardVariables_Response_DataWriter &);
            };

            class  GetBlackboardVariables_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetBlackboardVariables_Response_DataReader_ptr _ptr_type;
                typedef GetBlackboardVariables_Response_DataReader_var _var_type;

                static GetBlackboardVariables_Response_DataReader_ptr _duplicate (GetBlackboardVariables_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Response_& instance) = 0;

            protected:
                GetBlackboardVariables_Response_DataReader () {};
                ~GetBlackboardVariables_Response_DataReader () {};
            private:
                GetBlackboardVariables_Response_DataReader (const GetBlackboardVariables_Response_DataReader &);
                GetBlackboardVariables_Response_DataReader & operator = (const GetBlackboardVariables_Response_DataReader &);
            };

            class  GetBlackboardVariables_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetBlackboardVariables_Response_DataReaderView_ptr _ptr_type;
                typedef GetBlackboardVariables_Response_DataReaderView_var _var_type;

                static GetBlackboardVariables_Response_DataReaderView_ptr _duplicate (GetBlackboardVariables_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBlackboardVariables_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBlackboardVariables_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBlackboardVariables_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBlackboardVariables_Response_& instance) = 0;

            protected:
                GetBlackboardVariables_Response_DataReaderView () {};
                ~GetBlackboardVariables_Response_DataReaderView () {};
            private:
                GetBlackboardVariables_Response_DataReaderView (const GetBlackboardVariables_Response_DataReaderView &);
                GetBlackboardVariables_Response_DataReaderView & operator = (const GetBlackboardVariables_Response_DataReaderView &);
            };
            class Sample_GetBlackboardVariables_Request_TypeSupportInterface;

            typedef Sample_GetBlackboardVariables_Request_TypeSupportInterface * Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Request_TypeSupportInterface> Sample_GetBlackboardVariables_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Request_TypeSupportInterface> Sample_GetBlackboardVariables_Request_TypeSupportInterface_out;


            class Sample_GetBlackboardVariables_Request_DataWriter;

            typedef Sample_GetBlackboardVariables_Request_DataWriter * Sample_GetBlackboardVariables_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Request_DataWriter> Sample_GetBlackboardVariables_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Request_DataWriter> Sample_GetBlackboardVariables_Request_DataWriter_out;


            class Sample_GetBlackboardVariables_Request_DataReader;

            typedef Sample_GetBlackboardVariables_Request_DataReader * Sample_GetBlackboardVariables_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Request_DataReader> Sample_GetBlackboardVariables_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Request_DataReader> Sample_GetBlackboardVariables_Request_DataReader_out;


            class Sample_GetBlackboardVariables_Request_DataReaderView;

            typedef Sample_GetBlackboardVariables_Request_DataReaderView * Sample_GetBlackboardVariables_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Request_DataReaderView> Sample_GetBlackboardVariables_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Request_DataReaderView> Sample_GetBlackboardVariables_Request_DataReaderView_out;

            struct Sample_GetBlackboardVariables_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetBlackboardVariables_Request_, struct Sample_GetBlackboardVariables_Request_Seq_uniq_> Sample_GetBlackboardVariables_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetBlackboardVariables_Request_Seq> Sample_GetBlackboardVariables_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetBlackboardVariables_Request_Seq> Sample_GetBlackboardVariables_Request_Seq_out;

            class  Sample_GetBlackboardVariables_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Request_TypeSupportInterface_var _var_type;

                static Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _duplicate (Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetBlackboardVariables_Request_TypeSupportInterface () {};
                ~Sample_GetBlackboardVariables_Request_TypeSupportInterface () {};
            private:
                Sample_GetBlackboardVariables_Request_TypeSupportInterface (const Sample_GetBlackboardVariables_Request_TypeSupportInterface &);
                Sample_GetBlackboardVariables_Request_TypeSupportInterface & operator = (const Sample_GetBlackboardVariables_Request_TypeSupportInterface &);
            };

            class  Sample_GetBlackboardVariables_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetBlackboardVariables_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Request_DataWriter_var _var_type;

                static Sample_GetBlackboardVariables_Request_DataWriter_ptr _duplicate (Sample_GetBlackboardVariables_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetBlackboardVariables_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetBlackboardVariables_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetBlackboardVariables_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Request_& instance_data) = 0;

            protected:
                Sample_GetBlackboardVariables_Request_DataWriter () {};
                ~Sample_GetBlackboardVariables_Request_DataWriter () {};
            private:
                Sample_GetBlackboardVariables_Request_DataWriter (const Sample_GetBlackboardVariables_Request_DataWriter &);
                Sample_GetBlackboardVariables_Request_DataWriter & operator = (const Sample_GetBlackboardVariables_Request_DataWriter &);
            };

            class  Sample_GetBlackboardVariables_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetBlackboardVariables_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Request_DataReader_var _var_type;

                static Sample_GetBlackboardVariables_Request_DataReader_ptr _duplicate (Sample_GetBlackboardVariables_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Request_& instance) = 0;

            protected:
                Sample_GetBlackboardVariables_Request_DataReader () {};
                ~Sample_GetBlackboardVariables_Request_DataReader () {};
            private:
                Sample_GetBlackboardVariables_Request_DataReader (const Sample_GetBlackboardVariables_Request_DataReader &);
                Sample_GetBlackboardVariables_Request_DataReader & operator = (const Sample_GetBlackboardVariables_Request_DataReader &);
            };

            class  Sample_GetBlackboardVariables_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetBlackboardVariables_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Request_DataReaderView_var _var_type;

                static Sample_GetBlackboardVariables_Request_DataReaderView_ptr _duplicate (Sample_GetBlackboardVariables_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBlackboardVariables_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBlackboardVariables_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Request_& instance) = 0;

            protected:
                Sample_GetBlackboardVariables_Request_DataReaderView () {};
                ~Sample_GetBlackboardVariables_Request_DataReaderView () {};
            private:
                Sample_GetBlackboardVariables_Request_DataReaderView (const Sample_GetBlackboardVariables_Request_DataReaderView &);
                Sample_GetBlackboardVariables_Request_DataReaderView & operator = (const Sample_GetBlackboardVariables_Request_DataReaderView &);
            };
            class Sample_GetBlackboardVariables_Response_TypeSupportInterface;

            typedef Sample_GetBlackboardVariables_Response_TypeSupportInterface * Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Response_TypeSupportInterface> Sample_GetBlackboardVariables_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Response_TypeSupportInterface> Sample_GetBlackboardVariables_Response_TypeSupportInterface_out;


            class Sample_GetBlackboardVariables_Response_DataWriter;

            typedef Sample_GetBlackboardVariables_Response_DataWriter * Sample_GetBlackboardVariables_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Response_DataWriter> Sample_GetBlackboardVariables_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Response_DataWriter> Sample_GetBlackboardVariables_Response_DataWriter_out;


            class Sample_GetBlackboardVariables_Response_DataReader;

            typedef Sample_GetBlackboardVariables_Response_DataReader * Sample_GetBlackboardVariables_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Response_DataReader> Sample_GetBlackboardVariables_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Response_DataReader> Sample_GetBlackboardVariables_Response_DataReader_out;


            class Sample_GetBlackboardVariables_Response_DataReaderView;

            typedef Sample_GetBlackboardVariables_Response_DataReaderView * Sample_GetBlackboardVariables_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBlackboardVariables_Response_DataReaderView> Sample_GetBlackboardVariables_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetBlackboardVariables_Response_DataReaderView> Sample_GetBlackboardVariables_Response_DataReaderView_out;

            struct Sample_GetBlackboardVariables_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetBlackboardVariables_Response_, struct Sample_GetBlackboardVariables_Response_Seq_uniq_> Sample_GetBlackboardVariables_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetBlackboardVariables_Response_Seq> Sample_GetBlackboardVariables_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetBlackboardVariables_Response_Seq> Sample_GetBlackboardVariables_Response_Seq_out;

            class  Sample_GetBlackboardVariables_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Response_TypeSupportInterface_var _var_type;

                static Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _duplicate (Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetBlackboardVariables_Response_TypeSupportInterface () {};
                ~Sample_GetBlackboardVariables_Response_TypeSupportInterface () {};
            private:
                Sample_GetBlackboardVariables_Response_TypeSupportInterface (const Sample_GetBlackboardVariables_Response_TypeSupportInterface &);
                Sample_GetBlackboardVariables_Response_TypeSupportInterface & operator = (const Sample_GetBlackboardVariables_Response_TypeSupportInterface &);
            };

            class  Sample_GetBlackboardVariables_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetBlackboardVariables_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Response_DataWriter_var _var_type;

                static Sample_GetBlackboardVariables_Response_DataWriter_ptr _duplicate (Sample_GetBlackboardVariables_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetBlackboardVariables_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetBlackboardVariables_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetBlackboardVariables_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Response_& instance_data) = 0;

            protected:
                Sample_GetBlackboardVariables_Response_DataWriter () {};
                ~Sample_GetBlackboardVariables_Response_DataWriter () {};
            private:
                Sample_GetBlackboardVariables_Response_DataWriter (const Sample_GetBlackboardVariables_Response_DataWriter &);
                Sample_GetBlackboardVariables_Response_DataWriter & operator = (const Sample_GetBlackboardVariables_Response_DataWriter &);
            };

            class  Sample_GetBlackboardVariables_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetBlackboardVariables_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Response_DataReader_var _var_type;

                static Sample_GetBlackboardVariables_Response_DataReader_ptr _duplicate (Sample_GetBlackboardVariables_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Response_& instance) = 0;

            protected:
                Sample_GetBlackboardVariables_Response_DataReader () {};
                ~Sample_GetBlackboardVariables_Response_DataReader () {};
            private:
                Sample_GetBlackboardVariables_Response_DataReader (const Sample_GetBlackboardVariables_Response_DataReader &);
                Sample_GetBlackboardVariables_Response_DataReader & operator = (const Sample_GetBlackboardVariables_Response_DataReader &);
            };

            class  Sample_GetBlackboardVariables_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetBlackboardVariables_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetBlackboardVariables_Response_DataReaderView_var _var_type;

                static Sample_GetBlackboardVariables_Response_DataReaderView_ptr _duplicate (Sample_GetBlackboardVariables_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBlackboardVariables_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBlackboardVariables_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBlackboardVariables_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBlackboardVariables_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBlackboardVariables_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBlackboardVariables_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBlackboardVariables_Response_& instance) = 0;

            protected:
                Sample_GetBlackboardVariables_Response_DataReaderView () {};
                ~Sample_GetBlackboardVariables_Response_DataReaderView () {};
            private:
                Sample_GetBlackboardVariables_Response_DataReaderView (const Sample_GetBlackboardVariables_Response_DataReaderView &);
                Sample_GetBlackboardVariables_Response_DataReaderView & operator = (const Sample_GetBlackboardVariables_Response_DataReaderView &);
            };
        }

    }

}

#endif
