#ifndef _H_637F9E3CAB28AEE5FFF2B94214E25609_IntrospectPublishers__H_
#define _H_637F9E3CAB28AEE5FFF2B94214E25609_IntrospectPublishers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/PublisherDetails_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  IntrospectPublishers_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<IntrospectPublishers_Request_> IntrospectPublishers_Request__var;
            typedef IntrospectPublishers_Request_& IntrospectPublishers_Request__out;

            struct  IntrospectPublishers_Response_
            {
                struct _publisher_details__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::py_trees_ros_interfaces::msg::dds_::PublisherDetails_, struct _publisher_details__seq_uniq_ > _publisher_details__seq;
                typedef DDS_DCPSSequence_var< _publisher_details__seq > _publisher_details__seq_var;
                typedef DDS_DCPSSequence_out< _publisher_details__seq > _publisher_details__seq_out;
                _publisher_details__seq publisher_details_;
            };

            typedef DDS_DCPSStruct_var<IntrospectPublishers_Response_> IntrospectPublishers_Response__var;
            typedef DDS_DCPSStruct_out < IntrospectPublishers_Response_> IntrospectPublishers_Response__out;

            struct  Sample_IntrospectPublishers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectPublishers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectPublishers_Request_> Sample_IntrospectPublishers_Request__var;
            typedef Sample_IntrospectPublishers_Request_& Sample_IntrospectPublishers_Request__out;

            struct  Sample_IntrospectPublishers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectPublishers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectPublishers_Response_> Sample_IntrospectPublishers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_IntrospectPublishers_Response_> Sample_IntrospectPublishers_Response__out;

        }

    }

}

#endif /* _H_637F9E3CAB28AEE5FFF2B94214E25609_IntrospectPublishers__H_ */
