#ifndef _H_8BB973E85A3C331F66AB7F29D0BB87D4_IntrospectSubscribers__H_
#define _H_8BB973E85A3C331F66AB7F29D0BB87D4_IntrospectSubscribers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/SubscriberDetails_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  IntrospectSubscribers_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<IntrospectSubscribers_Request_> IntrospectSubscribers_Request__var;
            typedef IntrospectSubscribers_Request_& IntrospectSubscribers_Request__out;

            struct  IntrospectSubscribers_Response_
            {
                struct _subscriber_details__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::py_trees_ros_interfaces::msg::dds_::SubscriberDetails_, struct _subscriber_details__seq_uniq_ > _subscriber_details__seq;
                typedef DDS_DCPSSequence_var< _subscriber_details__seq > _subscriber_details__seq_var;
                typedef DDS_DCPSSequence_out< _subscriber_details__seq > _subscriber_details__seq_out;
                _subscriber_details__seq subscriber_details_;
            };

            typedef DDS_DCPSStruct_var<IntrospectSubscribers_Response_> IntrospectSubscribers_Response__var;
            typedef DDS_DCPSStruct_out < IntrospectSubscribers_Response_> IntrospectSubscribers_Response__out;

            struct  Sample_IntrospectSubscribers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectSubscribers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectSubscribers_Request_> Sample_IntrospectSubscribers_Request__var;
            typedef Sample_IntrospectSubscribers_Request_& Sample_IntrospectSubscribers_Request__out;

            struct  Sample_IntrospectSubscribers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::IntrospectSubscribers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_IntrospectSubscribers_Response_> Sample_IntrospectSubscribers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_IntrospectSubscribers_Response_> Sample_IntrospectSubscribers_Response__out;

        }

    }

}

#endif /* _H_8BB973E85A3C331F66AB7F29D0BB87D4_IntrospectSubscribers__H_ */
