#ifndef _H_58734DBCA4493BC528220B2A86968B43_BehaviourTree__H_
#define _H_58734DBCA4493BC528220B2A86968B43_BehaviourTree__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/Behaviour_.h"
#include "diagnostic_msgs/msg/dds_opensplice/KeyValue_.h"
#include "py_trees_ros_interfaces/msg/dds_opensplice/Statistics_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            struct  BehaviourTree_
            {
                struct _behaviours__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::py_trees_ros_interfaces::msg::dds_::Behaviour_, struct _behaviours__seq_uniq_ > _behaviours__seq;
                typedef DDS_DCPSSequence_var< _behaviours__seq > _behaviours__seq_var;
                typedef DDS_DCPSSequence_out< _behaviours__seq > _behaviours__seq_out;
                struct _blackboard_on_visited_path__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::diagnostic_msgs::msg::dds_::KeyValue_, struct _blackboard_on_visited_path__seq_uniq_ > _blackboard_on_visited_path__seq;
                typedef DDS_DCPSSequence_var< _blackboard_on_visited_path__seq > _blackboard_on_visited_path__seq_var;
                typedef DDS_DCPSSequence_out< _blackboard_on_visited_path__seq > _blackboard_on_visited_path__seq_out;
                _behaviours__seq behaviours_;
                _blackboard_on_visited_path__seq blackboard_on_visited_path_;
                ::DDS::String_mgr blackboard_activity_stream_;
                ::py_trees_ros_interfaces::msg::dds_::Statistics_ statistics_;
            };

            typedef DDS_DCPSStruct_var<BehaviourTree_> BehaviourTree__var;
            typedef DDS_DCPSStruct_out < BehaviourTree_> BehaviourTree__out;

        }

    }

}

#endif /* _H_58734DBCA4493BC528220B2A86968B43_BehaviourTree__H_ */
