#ifndef _H_FCD79F7F8BA0E25BB1A6C75FBEB22E77_Behaviour_DCPS_H_
#define _H_FCD79F7F8BA0E25BB1A6C75FBEB22E77_Behaviour_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Behaviour_.h"


namespace py_trees_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class Behaviour_TypeSupportInterface;

            typedef Behaviour_TypeSupportInterface * Behaviour_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Behaviour_TypeSupportInterface> Behaviour_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Behaviour_TypeSupportInterface> Behaviour_TypeSupportInterface_out;


            class Behaviour_DataWriter;

            typedef Behaviour_DataWriter * Behaviour_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Behaviour_DataWriter> Behaviour_DataWriter_var;
            typedef DDS_DCPSInterface_out < Behaviour_DataWriter> Behaviour_DataWriter_out;


            class Behaviour_DataReader;

            typedef Behaviour_DataReader * Behaviour_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Behaviour_DataReader> Behaviour_DataReader_var;
            typedef DDS_DCPSInterface_out < Behaviour_DataReader> Behaviour_DataReader_out;


            class Behaviour_DataReaderView;

            typedef Behaviour_DataReaderView * Behaviour_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Behaviour_DataReaderView> Behaviour_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Behaviour_DataReaderView> Behaviour_DataReaderView_out;

            struct Behaviour_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Behaviour_, struct Behaviour_Seq_uniq_> Behaviour_Seq;
            typedef DDS_DCPSSequence_var < Behaviour_Seq> Behaviour_Seq_var;
            typedef DDS_DCPSSequence_out < Behaviour_Seq> Behaviour_Seq_out;

            class  Behaviour_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Behaviour_TypeSupportInterface_ptr _ptr_type;
                typedef Behaviour_TypeSupportInterface_var _var_type;

                static Behaviour_TypeSupportInterface_ptr _duplicate (Behaviour_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Behaviour_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Behaviour_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Behaviour_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Behaviour_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Behaviour_TypeSupportInterface () {};
                ~Behaviour_TypeSupportInterface () {};
            private:
                Behaviour_TypeSupportInterface (const Behaviour_TypeSupportInterface &);
                Behaviour_TypeSupportInterface & operator = (const Behaviour_TypeSupportInterface &);
            };

            class  Behaviour_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Behaviour_DataWriter_ptr _ptr_type;
                typedef Behaviour_DataWriter_var _var_type;

                static Behaviour_DataWriter_ptr _duplicate (Behaviour_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Behaviour_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Behaviour_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Behaviour_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Behaviour_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Behaviour_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Behaviour_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Behaviour_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Behaviour_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Behaviour_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Behaviour_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Behaviour_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Behaviour_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Behaviour_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Behaviour_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Behaviour_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Behaviour_& instance_data) = 0;

            protected:
                Behaviour_DataWriter () {};
                ~Behaviour_DataWriter () {};
            private:
                Behaviour_DataWriter (const Behaviour_DataWriter &);
                Behaviour_DataWriter & operator = (const Behaviour_DataWriter &);
            };

            class  Behaviour_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Behaviour_DataReader_ptr _ptr_type;
                typedef Behaviour_DataReader_var _var_type;

                static Behaviour_DataReader_ptr _duplicate (Behaviour_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Behaviour_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Behaviour_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Behaviour_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Behaviour_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Behaviour_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Behaviour_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Behaviour_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Behaviour_& instance) = 0;

            protected:
                Behaviour_DataReader () {};
                ~Behaviour_DataReader () {};
            private:
                Behaviour_DataReader (const Behaviour_DataReader &);
                Behaviour_DataReader & operator = (const Behaviour_DataReader &);
            };

            class  Behaviour_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Behaviour_DataReaderView_ptr _ptr_type;
                typedef Behaviour_DataReaderView_var _var_type;

                static Behaviour_DataReaderView_ptr _duplicate (Behaviour_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Behaviour_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Behaviour_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Behaviour_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Behaviour_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Behaviour_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Behaviour_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Behaviour_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Behaviour_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Behaviour_& instance) = 0;

            protected:
                Behaviour_DataReaderView () {};
                ~Behaviour_DataReaderView () {};
            private:
                Behaviour_DataReaderView (const Behaviour_DataReaderView &);
                Behaviour_DataReaderView & operator = (const Behaviour_DataReaderView &);
            };
        }

    }

}

#endif
