#ifndef _H_2B3940AE606A8630ED9B3B86776CD470_OpenBlackboardWatcher_DCPS_H_
#define _H_2B3940AE606A8630ED9B3B86776CD470_OpenBlackboardWatcher_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OpenBlackboardWatcher_.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            class OpenBlackboardWatcher_Request_TypeSupportInterface;

            typedef OpenBlackboardWatcher_Request_TypeSupportInterface * OpenBlackboardWatcher_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Request_TypeSupportInterface> OpenBlackboardWatcher_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Request_TypeSupportInterface> OpenBlackboardWatcher_Request_TypeSupportInterface_out;


            class OpenBlackboardWatcher_Request_DataWriter;

            typedef OpenBlackboardWatcher_Request_DataWriter * OpenBlackboardWatcher_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Request_DataWriter> OpenBlackboardWatcher_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Request_DataWriter> OpenBlackboardWatcher_Request_DataWriter_out;


            class OpenBlackboardWatcher_Request_DataReader;

            typedef OpenBlackboardWatcher_Request_DataReader * OpenBlackboardWatcher_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Request_DataReader> OpenBlackboardWatcher_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Request_DataReader> OpenBlackboardWatcher_Request_DataReader_out;


            class OpenBlackboardWatcher_Request_DataReaderView;

            typedef OpenBlackboardWatcher_Request_DataReaderView * OpenBlackboardWatcher_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Request_DataReaderView> OpenBlackboardWatcher_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Request_DataReaderView> OpenBlackboardWatcher_Request_DataReaderView_out;

            struct OpenBlackboardWatcher_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenBlackboardWatcher_Request_, struct OpenBlackboardWatcher_Request_Seq_uniq_> OpenBlackboardWatcher_Request_Seq;
            typedef DDS_DCPSSequence_var < OpenBlackboardWatcher_Request_Seq> OpenBlackboardWatcher_Request_Seq_var;
            typedef DDS_DCPSSequence_out < OpenBlackboardWatcher_Request_Seq> OpenBlackboardWatcher_Request_Seq_out;

            class  OpenBlackboardWatcher_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Request_TypeSupportInterface_var _var_type;

                static OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _duplicate (OpenBlackboardWatcher_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenBlackboardWatcher_Request_TypeSupportInterface () {};
                ~OpenBlackboardWatcher_Request_TypeSupportInterface () {};
            private:
                OpenBlackboardWatcher_Request_TypeSupportInterface (const OpenBlackboardWatcher_Request_TypeSupportInterface &);
                OpenBlackboardWatcher_Request_TypeSupportInterface & operator = (const OpenBlackboardWatcher_Request_TypeSupportInterface &);
            };

            class  OpenBlackboardWatcher_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenBlackboardWatcher_Request_DataWriter_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Request_DataWriter_var _var_type;

                static OpenBlackboardWatcher_Request_DataWriter_ptr _duplicate (OpenBlackboardWatcher_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenBlackboardWatcher_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenBlackboardWatcher_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Request_& instance_data) = 0;

            protected:
                OpenBlackboardWatcher_Request_DataWriter () {};
                ~OpenBlackboardWatcher_Request_DataWriter () {};
            private:
                OpenBlackboardWatcher_Request_DataWriter (const OpenBlackboardWatcher_Request_DataWriter &);
                OpenBlackboardWatcher_Request_DataWriter & operator = (const OpenBlackboardWatcher_Request_DataWriter &);
            };

            class  OpenBlackboardWatcher_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenBlackboardWatcher_Request_DataReader_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Request_DataReader_var _var_type;

                static OpenBlackboardWatcher_Request_DataReader_ptr _duplicate (OpenBlackboardWatcher_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Request_& instance) = 0;

            protected:
                OpenBlackboardWatcher_Request_DataReader () {};
                ~OpenBlackboardWatcher_Request_DataReader () {};
            private:
                OpenBlackboardWatcher_Request_DataReader (const OpenBlackboardWatcher_Request_DataReader &);
                OpenBlackboardWatcher_Request_DataReader & operator = (const OpenBlackboardWatcher_Request_DataReader &);
            };

            class  OpenBlackboardWatcher_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenBlackboardWatcher_Request_DataReaderView_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Request_DataReaderView_var _var_type;

                static OpenBlackboardWatcher_Request_DataReaderView_ptr _duplicate (OpenBlackboardWatcher_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Request_& instance) = 0;

            protected:
                OpenBlackboardWatcher_Request_DataReaderView () {};
                ~OpenBlackboardWatcher_Request_DataReaderView () {};
            private:
                OpenBlackboardWatcher_Request_DataReaderView (const OpenBlackboardWatcher_Request_DataReaderView &);
                OpenBlackboardWatcher_Request_DataReaderView & operator = (const OpenBlackboardWatcher_Request_DataReaderView &);
            };
            class OpenBlackboardWatcher_Response_TypeSupportInterface;

            typedef OpenBlackboardWatcher_Response_TypeSupportInterface * OpenBlackboardWatcher_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Response_TypeSupportInterface> OpenBlackboardWatcher_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Response_TypeSupportInterface> OpenBlackboardWatcher_Response_TypeSupportInterface_out;


            class OpenBlackboardWatcher_Response_DataWriter;

            typedef OpenBlackboardWatcher_Response_DataWriter * OpenBlackboardWatcher_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Response_DataWriter> OpenBlackboardWatcher_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Response_DataWriter> OpenBlackboardWatcher_Response_DataWriter_out;


            class OpenBlackboardWatcher_Response_DataReader;

            typedef OpenBlackboardWatcher_Response_DataReader * OpenBlackboardWatcher_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Response_DataReader> OpenBlackboardWatcher_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Response_DataReader> OpenBlackboardWatcher_Response_DataReader_out;


            class OpenBlackboardWatcher_Response_DataReaderView;

            typedef OpenBlackboardWatcher_Response_DataReaderView * OpenBlackboardWatcher_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OpenBlackboardWatcher_Response_DataReaderView> OpenBlackboardWatcher_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OpenBlackboardWatcher_Response_DataReaderView> OpenBlackboardWatcher_Response_DataReaderView_out;

            struct OpenBlackboardWatcher_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OpenBlackboardWatcher_Response_, struct OpenBlackboardWatcher_Response_Seq_uniq_> OpenBlackboardWatcher_Response_Seq;
            typedef DDS_DCPSSequence_var < OpenBlackboardWatcher_Response_Seq> OpenBlackboardWatcher_Response_Seq_var;
            typedef DDS_DCPSSequence_out < OpenBlackboardWatcher_Response_Seq> OpenBlackboardWatcher_Response_Seq_out;

            class  OpenBlackboardWatcher_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Response_TypeSupportInterface_var _var_type;

                static OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _duplicate (OpenBlackboardWatcher_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OpenBlackboardWatcher_Response_TypeSupportInterface () {};
                ~OpenBlackboardWatcher_Response_TypeSupportInterface () {};
            private:
                OpenBlackboardWatcher_Response_TypeSupportInterface (const OpenBlackboardWatcher_Response_TypeSupportInterface &);
                OpenBlackboardWatcher_Response_TypeSupportInterface & operator = (const OpenBlackboardWatcher_Response_TypeSupportInterface &);
            };

            class  OpenBlackboardWatcher_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OpenBlackboardWatcher_Response_DataWriter_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Response_DataWriter_var _var_type;

                static OpenBlackboardWatcher_Response_DataWriter_ptr _duplicate (OpenBlackboardWatcher_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OpenBlackboardWatcher_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OpenBlackboardWatcher_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Response_& instance_data) = 0;

            protected:
                OpenBlackboardWatcher_Response_DataWriter () {};
                ~OpenBlackboardWatcher_Response_DataWriter () {};
            private:
                OpenBlackboardWatcher_Response_DataWriter (const OpenBlackboardWatcher_Response_DataWriter &);
                OpenBlackboardWatcher_Response_DataWriter & operator = (const OpenBlackboardWatcher_Response_DataWriter &);
            };

            class  OpenBlackboardWatcher_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OpenBlackboardWatcher_Response_DataReader_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Response_DataReader_var _var_type;

                static OpenBlackboardWatcher_Response_DataReader_ptr _duplicate (OpenBlackboardWatcher_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Response_& instance) = 0;

            protected:
                OpenBlackboardWatcher_Response_DataReader () {};
                ~OpenBlackboardWatcher_Response_DataReader () {};
            private:
                OpenBlackboardWatcher_Response_DataReader (const OpenBlackboardWatcher_Response_DataReader &);
                OpenBlackboardWatcher_Response_DataReader & operator = (const OpenBlackboardWatcher_Response_DataReader &);
            };

            class  OpenBlackboardWatcher_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OpenBlackboardWatcher_Response_DataReaderView_ptr _ptr_type;
                typedef OpenBlackboardWatcher_Response_DataReaderView_var _var_type;

                static OpenBlackboardWatcher_Response_DataReaderView_ptr _duplicate (OpenBlackboardWatcher_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OpenBlackboardWatcher_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OpenBlackboardWatcher_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OpenBlackboardWatcher_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OpenBlackboardWatcher_Response_& instance) = 0;

            protected:
                OpenBlackboardWatcher_Response_DataReaderView () {};
                ~OpenBlackboardWatcher_Response_DataReaderView () {};
            private:
                OpenBlackboardWatcher_Response_DataReaderView (const OpenBlackboardWatcher_Response_DataReaderView &);
                OpenBlackboardWatcher_Response_DataReaderView & operator = (const OpenBlackboardWatcher_Response_DataReaderView &);
            };
            class Sample_OpenBlackboardWatcher_Request_TypeSupportInterface;

            typedef Sample_OpenBlackboardWatcher_Request_TypeSupportInterface * Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Request_TypeSupportInterface> Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Request_TypeSupportInterface> Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_out;


            class Sample_OpenBlackboardWatcher_Request_DataWriter;

            typedef Sample_OpenBlackboardWatcher_Request_DataWriter * Sample_OpenBlackboardWatcher_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Request_DataWriter> Sample_OpenBlackboardWatcher_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Request_DataWriter> Sample_OpenBlackboardWatcher_Request_DataWriter_out;


            class Sample_OpenBlackboardWatcher_Request_DataReader;

            typedef Sample_OpenBlackboardWatcher_Request_DataReader * Sample_OpenBlackboardWatcher_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Request_DataReader> Sample_OpenBlackboardWatcher_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Request_DataReader> Sample_OpenBlackboardWatcher_Request_DataReader_out;


            class Sample_OpenBlackboardWatcher_Request_DataReaderView;

            typedef Sample_OpenBlackboardWatcher_Request_DataReaderView * Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Request_DataReaderView> Sample_OpenBlackboardWatcher_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Request_DataReaderView> Sample_OpenBlackboardWatcher_Request_DataReaderView_out;

            struct Sample_OpenBlackboardWatcher_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenBlackboardWatcher_Request_, struct Sample_OpenBlackboardWatcher_Request_Seq_uniq_> Sample_OpenBlackboardWatcher_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenBlackboardWatcher_Request_Seq> Sample_OpenBlackboardWatcher_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenBlackboardWatcher_Request_Seq> Sample_OpenBlackboardWatcher_Request_Seq_out;

            class  Sample_OpenBlackboardWatcher_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_var _var_type;

                static Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _duplicate (Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenBlackboardWatcher_Request_TypeSupportInterface () {};
                ~Sample_OpenBlackboardWatcher_Request_TypeSupportInterface () {};
            private:
                Sample_OpenBlackboardWatcher_Request_TypeSupportInterface (const Sample_OpenBlackboardWatcher_Request_TypeSupportInterface &);
                Sample_OpenBlackboardWatcher_Request_TypeSupportInterface & operator = (const Sample_OpenBlackboardWatcher_Request_TypeSupportInterface &);
            };

            class  Sample_OpenBlackboardWatcher_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Request_DataWriter_var _var_type;

                static Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _duplicate (Sample_OpenBlackboardWatcher_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenBlackboardWatcher_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenBlackboardWatcher_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenBlackboardWatcher_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Request_& instance_data) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Request_DataWriter () {};
                ~Sample_OpenBlackboardWatcher_Request_DataWriter () {};
            private:
                Sample_OpenBlackboardWatcher_Request_DataWriter (const Sample_OpenBlackboardWatcher_Request_DataWriter &);
                Sample_OpenBlackboardWatcher_Request_DataWriter & operator = (const Sample_OpenBlackboardWatcher_Request_DataWriter &);
            };

            class  Sample_OpenBlackboardWatcher_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Request_DataReader_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Request_DataReader_var _var_type;

                static Sample_OpenBlackboardWatcher_Request_DataReader_ptr _duplicate (Sample_OpenBlackboardWatcher_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Request_& instance) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Request_DataReader () {};
                ~Sample_OpenBlackboardWatcher_Request_DataReader () {};
            private:
                Sample_OpenBlackboardWatcher_Request_DataReader (const Sample_OpenBlackboardWatcher_Request_DataReader &);
                Sample_OpenBlackboardWatcher_Request_DataReader & operator = (const Sample_OpenBlackboardWatcher_Request_DataReader &);
            };

            class  Sample_OpenBlackboardWatcher_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Request_DataReaderView_var _var_type;

                static Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _duplicate (Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardWatcher_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardWatcher_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Request_& instance) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Request_DataReaderView () {};
                ~Sample_OpenBlackboardWatcher_Request_DataReaderView () {};
            private:
                Sample_OpenBlackboardWatcher_Request_DataReaderView (const Sample_OpenBlackboardWatcher_Request_DataReaderView &);
                Sample_OpenBlackboardWatcher_Request_DataReaderView & operator = (const Sample_OpenBlackboardWatcher_Request_DataReaderView &);
            };
            class Sample_OpenBlackboardWatcher_Response_TypeSupportInterface;

            typedef Sample_OpenBlackboardWatcher_Response_TypeSupportInterface * Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Response_TypeSupportInterface> Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Response_TypeSupportInterface> Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_out;


            class Sample_OpenBlackboardWatcher_Response_DataWriter;

            typedef Sample_OpenBlackboardWatcher_Response_DataWriter * Sample_OpenBlackboardWatcher_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Response_DataWriter> Sample_OpenBlackboardWatcher_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Response_DataWriter> Sample_OpenBlackboardWatcher_Response_DataWriter_out;


            class Sample_OpenBlackboardWatcher_Response_DataReader;

            typedef Sample_OpenBlackboardWatcher_Response_DataReader * Sample_OpenBlackboardWatcher_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Response_DataReader> Sample_OpenBlackboardWatcher_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Response_DataReader> Sample_OpenBlackboardWatcher_Response_DataReader_out;


            class Sample_OpenBlackboardWatcher_Response_DataReaderView;

            typedef Sample_OpenBlackboardWatcher_Response_DataReaderView * Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_OpenBlackboardWatcher_Response_DataReaderView> Sample_OpenBlackboardWatcher_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_OpenBlackboardWatcher_Response_DataReaderView> Sample_OpenBlackboardWatcher_Response_DataReaderView_out;

            struct Sample_OpenBlackboardWatcher_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_OpenBlackboardWatcher_Response_, struct Sample_OpenBlackboardWatcher_Response_Seq_uniq_> Sample_OpenBlackboardWatcher_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_OpenBlackboardWatcher_Response_Seq> Sample_OpenBlackboardWatcher_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_OpenBlackboardWatcher_Response_Seq> Sample_OpenBlackboardWatcher_Response_Seq_out;

            class  Sample_OpenBlackboardWatcher_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_var _var_type;

                static Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _duplicate (Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_OpenBlackboardWatcher_Response_TypeSupportInterface () {};
                ~Sample_OpenBlackboardWatcher_Response_TypeSupportInterface () {};
            private:
                Sample_OpenBlackboardWatcher_Response_TypeSupportInterface (const Sample_OpenBlackboardWatcher_Response_TypeSupportInterface &);
                Sample_OpenBlackboardWatcher_Response_TypeSupportInterface & operator = (const Sample_OpenBlackboardWatcher_Response_TypeSupportInterface &);
            };

            class  Sample_OpenBlackboardWatcher_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Response_DataWriter_var _var_type;

                static Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _duplicate (Sample_OpenBlackboardWatcher_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_OpenBlackboardWatcher_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_OpenBlackboardWatcher_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_OpenBlackboardWatcher_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Response_& instance_data) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Response_DataWriter () {};
                ~Sample_OpenBlackboardWatcher_Response_DataWriter () {};
            private:
                Sample_OpenBlackboardWatcher_Response_DataWriter (const Sample_OpenBlackboardWatcher_Response_DataWriter &);
                Sample_OpenBlackboardWatcher_Response_DataWriter & operator = (const Sample_OpenBlackboardWatcher_Response_DataWriter &);
            };

            class  Sample_OpenBlackboardWatcher_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Response_DataReader_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Response_DataReader_var _var_type;

                static Sample_OpenBlackboardWatcher_Response_DataReader_ptr _duplicate (Sample_OpenBlackboardWatcher_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Response_& instance) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Response_DataReader () {};
                ~Sample_OpenBlackboardWatcher_Response_DataReader () {};
            private:
                Sample_OpenBlackboardWatcher_Response_DataReader (const Sample_OpenBlackboardWatcher_Response_DataReader &);
                Sample_OpenBlackboardWatcher_Response_DataReader & operator = (const Sample_OpenBlackboardWatcher_Response_DataReader &);
            };

            class  Sample_OpenBlackboardWatcher_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_OpenBlackboardWatcher_Response_DataReaderView_var _var_type;

                static Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _duplicate (Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_OpenBlackboardWatcher_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_OpenBlackboardWatcher_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_OpenBlackboardWatcher_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_OpenBlackboardWatcher_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_OpenBlackboardWatcher_Response_& instance) = 0;

            protected:
                Sample_OpenBlackboardWatcher_Response_DataReaderView () {};
                ~Sample_OpenBlackboardWatcher_Response_DataReaderView () {};
            private:
                Sample_OpenBlackboardWatcher_Response_DataReaderView (const Sample_OpenBlackboardWatcher_Response_DataReaderView &);
                Sample_OpenBlackboardWatcher_Response_DataReaderView & operator = (const Sample_OpenBlackboardWatcher_Response_DataReaderView &);
            };
        }

    }

}

#endif
