#ifndef _H_30F75202D459E5D40243251E6A50868B_StatusReport__H_
#define _H_30F75202D459E5D40243251E6A50868B_StatusReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace py_trees_ros_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  StatusReport_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<StatusReport_Request_> StatusReport_Request__var;
            typedef StatusReport_Request_& StatusReport_Request__out;

            struct  StatusReport_Response_
            {
                ::DDS::String_mgr report_;
            };

            typedef DDS_DCPSStruct_var<StatusReport_Response_> StatusReport_Response__var;
            typedef DDS_DCPSStruct_out < StatusReport_Response_> StatusReport_Response__out;

            struct  Sample_StatusReport_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::StatusReport_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_StatusReport_Request_> Sample_StatusReport_Request__var;
            typedef Sample_StatusReport_Request_& Sample_StatusReport_Request__out;

            struct  Sample_StatusReport_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::py_trees_ros_interfaces::srv::dds_::StatusReport_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_StatusReport_Response_> Sample_StatusReport_Response__var;
            typedef DDS_DCPSStruct_out < Sample_StatusReport_Response_> Sample_StatusReport_Response__out;

        }

    }

}

#endif /* _H_30F75202D459E5D40243251E6A50868B_StatusReport__H_ */
